﻿using System;
using System.ComponentModel;
using Xamarin.Forms;

namespace PlatformRgbSliders
{
    class RgbColorViewModel : INotifyPropertyChanged
    {
        double red, green, blue;

        public event PropertyChangedEventHandler PropertyChanged;

        public double Red
        {
            set
            {
                if (red != value)
                {
                    red = value;
                    OnPropertyChanged("Red");
                    OnPropertyChanged("Color");
                }
            }
            get { return red; }
        }

        public double Green
        {
            set
            {
                if (green != value)
                {
                    green = value;
                    OnPropertyChanged("Green");
                    OnPropertyChanged("Color");
                }
            }
            get { return green; }
        }

        public double Blue
        {
            set
            {
                if (blue != value)
                {
                    blue = value;
                    OnPropertyChanged("Blue");
                    OnPropertyChanged("Color");
                }
            }
            get { return blue; }
        }

        public Color Color
        {
            set
            {
                Red = value.R;
                Green = value.G;
                Blue = value.B;
            }
            get { return Color.FromRgb(Red, Green, Blue); }
        }

        protected void OnPropertyChanged(string propertyName)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
