﻿using System;
using System.Collections.Generic;

using Android.Content;
using Android.Widget;

namespace PlatformSpinners.Droid
{
  class PropertiedSpinner : Spinner
  {
    ArrayAdapter adapter;
    IList<string> items;

    public PropertiedSpinner(Context context) : base(context)
    {
      ItemSelected += OnBindableSpinnerItemSelected;

      adapter = new ArrayAdapter(context, Android.Resource.Layout.SimpleSpinnerItem);
      adapter.SetDropDownViewResource(Android.Resource.Layout.SimpleSpinnerDropDownItem);
      Adapter = adapter;
    }

    void OnBindableSpinnerItemSelected(object sender, ItemSelectedEventArgs args)
    {
      SelectedObject = (string)GetItemAtPosition(args.Position);
    }

    public IList<string> Items
    {
      set
      {
        if (items != value)
        {
          items = value;
          adapter.Clear();

          foreach (string str in items)
          {
            adapter.Add(str);
          }
        }
      }

      get
      {
        return items;
      }
    }

    public string SelectedObject
    {
      set
      {
        if (items != null)
        {
          int index = items.IndexOf(value);
          if (index != -1)
          {
            SetSelection(index);
          }
        }
      }
      get
      {
        return (string)GetItemAtPosition(SelectedItemPosition);
      }
    }
  }
}
