﻿using System;
using System.Collections.Generic;
using UIKit;

namespace PlatformSpinners.iOS
{
  public class PropertiedUIPickerView : UIPickerView
  {
    public event EventHandler<EventArgs> ValueChanged;

    public PropertiedUIPickerView()
    {
      PickerDataModel model = new PickerDataModel();
      model.ValueChanged += (sender, args) => ValueChanged?.Invoke(this, args);
      Model = model;
    }

    public IList<string> Items
    {
      set
      {
        PickerDataModel dataModel = Model as PickerDataModel;

        if (dataModel != null)
        {
          dataModel.Items = value;
        }
      }
      get
      {
        return (Model as PickerDataModel)?.Items;
      }
    }

    public string SelectedItem
    {
      set
      {
      }

      get
      {
        return (Model as PickerDataModel).SelectedItem;
      }
    }
  }
}
