﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using Xamarin.Forms;

namespace PlatformSpinners
{
  class ColorNameViewModel : INotifyPropertyChanged
  {
    IList<string> colorNames;
    string selectedColorName = "Black";
    ColorTypeConverter colorTypeConverter = new ColorTypeConverter();

    public event PropertyChangedEventHandler PropertyChanged;

    public ColorNameViewModel()
    {
      ColorNames = new List<string>
      {
          "Black", "Gray", "Silver", "White",
          "Red", "Maroon", "Yellow", "Olive",
          "Lime", "Green", "Aqua", "Teal",
          "Blue", "Navy", "Fuchsia", "Purple", "Pink"
      };
    }

    public IList<string> ColorNames
    {
      private set
      {
        colorNames = value;
      }

      get
      {
        return colorNames;
      }
    }

    public string SelectedColorName
    {
      set
      {
        if (selectedColorName != value)
        {
          selectedColorName = value;
          OnPropertyChanged("SelectedColorName");
          OnPropertyChanged("SelectedColor");
        }
      }
      get { return selectedColorName; }
    }

    public Color SelectedColor
    {
      get
      {
        if (String.IsNullOrEmpty(selectedColorName))
        {
          return Color.Black;
        }
        return (Color)colorTypeConverter.ConvertFromInvariantString(selectedColorName);
      }
    }

    protected void OnPropertyChanged(string propertyName)
    {
      PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
    }
  }
}
